rebol [
    title: "emailine"
    version: 1.0
    date: 2010
    author: neosysta
    email: contact@neosysta.com
    url: http://www.neosysta.com
]


COMPTE: read/lines %licence

base-emailings: "../base/emailings/"
base-emails: "../base/emails/"
base-messages: "../base/messages/"
base-logs: "../base/logs/"

liste-emailings: []
liste-emails-emailings: []


init-emailing: [
    clear liste-emailings
    liste-emailings-emailing/data: liste-emailings
    show liste-emailings-emailing
    clear liste-emails-emailings
    liste-emails-emailing/data: liste-emails-emailings
    show liste-emails-emailing

    clear-fields fiche-emailing show fiche-emailing
    clear message-emailing/text show message-emailing
    clear-fields popup-emails-emailing show popup-emails-emailing
    fichier-emailing: ""
    donnees-emailing: ""
    fichier-message: ""
    donnees-message: ""
]


popup-apropos: center-face layout/size [
    style bouton button with [ effect: [ gradient 1x1 black orange ] ]

    below
    pad 0x10
    button 255x37 "" %maxi-neosysta.bmp [ browse http://www.neosysta.com ]
    pad 20x20
    vh1 215 center "emailine v1.0"
    pad 5
    h2 215 center "Janvier 2010"
    pad 10
    h2 215 center "www.neosysta.com"
    pad 5
    h2 215 center "contact@neosysta.com"
    pad 10
    h4 215 center ""
    h4 215 center ""
    h4 215 center ""
    pad 90x20
    bouton 40 "OK" #"^m" [ unview ]
    bouton 0 "" #"^(ESC)" [ unview ]
    pad -90x-20
    text 215 center "Copyright 2008-2010, neosysta."

] 300x425


popup-emails-emailing: center-face layout/size [
    style bouton button with [ effect: [ gradient 1x1 black orange ] ]

    origin 0x0
    across
    critere-email-emailing: field 225
    bouton "Rechercher" [
        critere-email-emailing/text: uppercase trim critere-email-emailing/text show critere-email-emailing
        fiches-emails: open to-file base-emails
        clear liste-emails-emailings
        either not empty? critere-email-emailing/text [
            forall fiches-emails [
                 if find first fiches-emails critere-email-emailing/text [ insert tail liste-emails-emailings first fiches-emails ]
            ]
        ] [
            forall fiches-emails [
                 insert tail liste-emails-emailings first fiches-emails
            ]
        ]
        close fiches-emails
        liste-emails-emailing/data: sort liste-emails-emailings
        show liste-emails-emailing
    ] return

    below
    liste-emails-emailing: text-list 350x490 font-size 16 bold [
        email-picked: form liste-emails-emailing/picked
        fichier-email: join base-emails email-picked
        either error? try [ donnees-email: read/lines to-file fichier-email ] [ alert "Erreur d'acces" ] [
            if error? try [ a-emails-emailing/text: trim email-picked show a-emails-emailing ] []
            unview/only popup-emails-emailing
        ]
    ]
    button 0 "" #"^(ESC)" [ unview/only popup-emails-emailing ]

] 350x520


view fiche-emailing: center-face layout/size [
    backdrop effect [ gradient 0x1 brown ]
    style bouton button with [ effect: [ gradient 1x1 black orange ] ]
    style rchoix rotary with [ effect: [ gradient 1x1 black orange ] ]

    across
    button 212x37 "" %mini-neosysta.bmp [ browse http://www.neosysta.com ]
    pad 590 vh1 "emailine" bold bouton 25 "?" [ view/new/title popup-apropos "emailine - a propos" ]
    below

    box 950x1 white
    pad 660
    text 950 center "Copyright 2008-2010, neosysta."

    origin 20x700
    h5 950 center join trim COMPTE/1 [ " - " trim COMPTE/2 ]

    origin 20x80
    vh2 "Selection :"
    across
    critere-emailing: field 225
    bouton "Rechercher" [
        critere-emailing/text: uppercase trim critere-emailing/text show critere-emailing
        fiches-emailings: open to-file base-emailings
        clear liste-emailings
        either not empty? critere-emailing/text [
            forall fiches-emailings [
                 if find first fiches-emailings critere-emailing/text [ insert tail liste-emailings first fiches-emailings ]
            ]
        ] [
            forall fiches-emailings [
                 insert tail liste-emailings first fiches-emailings
            ]
        ]
        close fiches-emailings
        liste-emailings-emailing/data: sort liste-emailings
        show liste-emailings-emailing
    ] return

    below
    liste-emailings-emailing: text-list 350x550 font-size 16 bold [
        emailing-picked: form liste-emailings-emailing/picked
        fichier-emailing: join base-emailings emailing-picked
        fichier-message: join base-messages emailing-picked
        either error? try [ donnees-emailing: read/lines to-file fichier-emailing donnees-message: read to-file fichier-message ] [ alert "Erreur d'acces" ] [
            clear-fields fiche-emailing show fiche-emailing
            if error? try [ intitule-emailing/text: trim donnees-emailing/1 show intitule-emailing ] []
            if error? try [ smtp-emailing/text: trim donnees-emailing/2 show smtp-emailing ] []
            if error? try [ pop-emailing/text: trim donnees-emailing/3 show pop-emailing ] []
            if error? try [ de-nom-emailing/text: trim donnees-emailing/4 show de-nom-emailing ] []
            if error? try [ de-email-emailing/text: trim donnees-emailing/5 show de-email-emailing ] []
            if error? try [ a-emails-emailing/text: trim donnees-emailing/6 show a-emails-emailing ] []
            if error? try [ sujet-emailing/text: trim donnees-emailing/7 show sujet-emailing ] []
            if error? try [ message-emailing/text: donnees-message show message-emailing ] []
            if error? try [ maj-emailing/text: trim donnees-emailing/8 show maj-emailing ] []
        ]
    ]

    origin 390x80
    vh2 "Saisie e-Mailing :"
    across
    lab red "Intitule" intitule-emailing: field 250 return
    lab "SMTP" smtp-emailing: field lab "POP" pop-emailing: field return
    lab "De (nom)" de-nom-emailing: field 250 return
    lab "De (e-Mail)" de-email-emailing: field 250 return
    lab "A (e-Mails)" a-emails-emailing: info 250 bouton 25 "+" [ view/new/title popup-emails-emailing "emailine - emails" ]
    email-trt-emailing: info bold font [color: yellow ] return
    lab "Sujet" sujet-emailing: field 491 return
    lab "Message" message-emailing: area 491x300 wrap return
    lab "Mise a jour" maj-emailing: info 150 lab "Tempo (s)" tempo-emailing: rchoix 50 "0" "1" "2" "3" "4" "5" "10" "30" "60" return

    pad 0x15
    bouton "Envoyer" [
        either (not empty? a-emails-emailing/text) [
            if request/confirm [ "Lancer l'e-Mailing ?" "Oui" "Non" ] [
                either error? try [
                    system/user/name: trim de-nom-emailing/text
                    system/user/email: to-email trim de-email-emailing/text
                    system/schemes/default/host: trim smtp-emailing/text
                    system/schemes/pop/host: trim pop-emailing/text

                    fichier-emails: join base-emails a-emails-emailing/text
                    emails: read/lines to-file fichier-emails
                    sujet: trim sujet-emailing/text
                    message: message-emailing/text
                    nb: 0

                    nom-log: join "log" [ now/year now/month now/day now/time ".txt" ]
                    replace/all nom-log ":" ""
                    fichier-log: join base-logs nom-log
                    emailing: uppercase trim intitule-emailing/text
                    ligne-log: reform [ emailing "- DEBUT" now newline ]
                    write to-file fichier-log ligne-log

                    foreach [ destinataire ] emails [
                        nb: nb + 1
                        email-trt: join to-string nb [ " - " destinataire ]
                        email-trt-emailing/text: email-trt show email-trt-emailing
                        if not error? try [ ligne-err: disarm try [ send/subject to-email trim destinataire message sujet ] ] [
                            ligne-log: reform [ emailing "- ERREUR" destinataire "=>" to-string ligne-err/id to-string ligne-err/arg1 newline ]
                            write/append to-file fichier-log ligne-log
                        ]
                        wait to-integer tempo-emailing/text
                    ]

                    ligne-log: reform [ emailing "- FIN" now newline ]
                    write/append to-file fichier-log ligne-log
                ] [ alert "Erreur de traitement" ] [ alert "Fin de traitement" ]
                clear email-trt-emailing/text show email-trt-emailing
            ]
        ] [ alert "Donnees saisies invalides" ]
    ]

    bouton "Enregistrer" [
        if error? try [
            intitule-emailing/text: uppercase trim intitule-emailing/text show intitule-emailing

            either (not empty? intitule-emailing/text) [
                fichier-emailing: join base-emailings intitule-emailing/text
                donnees-emailing: reform [ intitule-emailing/text newline smtp-emailing/text newline pop-emailing/text newline de-nom-emailing/text newline de-email-emailing/text newline a-emails-emailing/text newline sujet-emailing/text newline now ]
                fichier-message: join base-messages intitule-emailing/text
                donnees-message: message-emailing/text

                either (exists? to-file fichier-emailing) [
                    if request/confirm [ "Remplacer les donnees existantes ?" "Oui" "Non" ] [
                        write to-file fichier-emailing donnees-emailing
                        write to-file fichier-message donnees-message
                        do init-emailing
                    ]
                ] [
                        write to-file fichier-emailing donnees-emailing
                        write to-file fichier-message donnees-message
                        do init-emailing
                ]
            ] [ alert "Donnees saisies invalides" ]
        ] [ alert "Erreur d'enregistrement" ]
    ]

    bouton "Supprimer" [
        if error? try [
            if request/confirm [ "Supprimer l'e-Mailing ?" "Oui" "Non" ] [
                delete to-file fichier-emailing
                delete to-file fichier-message
                do init-emailing
            ]
        ] [ alert "Erreur de suppression" ]
    ]

    bouton "Effacer" [
        do init-emailing
    ]

    bouton "Quitter" [ quit ]

] 1024x768
